#include "select-demo.h"

#if DEMO == DEMO_HTTP

#include "mbed.h"
#include "easy-connect.h"
#include "http_request.h"

Serial pc(USBTX, USBRX);
Timer t;
void dump_response(HttpResponse* res) {
    printf("Status: %d - %s\n", res->get_status_code(), res->get_status_message().c_str());

    printf("Headers:\n");
    for (size_t ix = 0; ix < res->get_headers_length(); ix++) {
        printf("\t%s: %s\n", res->get_headers_fields()[ix]->c_str(), res->get_headers_values()[ix]->c_str());
    }
    printf("\nBody (%d bytes):\n\n%s\n", res->get_body_length(), res->get_body_as_string().c_str());
}

void body_callback(const char* data, size_t data_len) {
    // simply return, leading to the data being lost.
    // Necessary for large sizes in order to ensure that there isn't an 
    // exhaustion of memory with the large video test.
    return;
}

int main() {
    pc.baud(115200);
    // Connect to the network (see mbed_app.json for the connectivity method used)
    for(int i=1;i<10;i++) {
        printf("Hello?\n");
}
    NetworkInterface *network = easy_connect(true);
    if (!network) {
        printf("Cannot connect to the network, see serial output");
        return 1;
    }

    printf("See if it gives any debug info");

    // Do a GET request to httpbin.org
    //while(1)
    {
        // By default the body is automatically parsed and stored in a buffer, this is memory heavy.
        // To receive chunked response, pass in a callback as last parameter to the constructor.
        t.start();
        // HttpRequest* get_req = new HttpRequest(network, HTTP_GET, "https://www.google.com/search?q=%E2%80%9CTrading+Structure+for+Randomness+in+Wireless+Opportunistic+Routing%E2%80%9D&oq=%E2%80%9CTrading+Structure+for+Randomness+in+Wireless+Opportunistic+Routing%E2%80%9D&aqs=chrome..69i57j0j69i60.1298j0j8&sourceid=chrome&ie=UTF-8");
        HttpRequest* get_req = new HttpRequest(network, HTTP_GET, "http://httpbin.org/status/418");
        HttpResponse* get_res = get_req->send();
        t.stop();
        printf("loading time: %f \n",t.read());
        printf("Body_length: %d \n", get_res->get_body_length());
        
        if (!get_res) {
            printf("HttpRequest failed (error code %d)\n", get_req->get_error());
            return 1;
        }

        printf("\n----- HTTP GET response -----\n");
        dump_response(get_res);
        t.reset();

        delete get_req;
    }

    // POST request to httpbin.org
    //{
//        HttpRequest* post_req = new HttpRequest(network, HTTP_POST, "http://httpbin.org/post");
//        post_req->set_header("Content-Type", "application/json");
//
//        const char body[] = "{\"hello\":\"world\"}";
//
//        HttpResponse* post_res = post_req->send(body, strlen(body));
//        if (!post_res) {
//            printf("HttpRequest failed (error code %d)\n", post_req->get_error());
//            return 1;
//        }
//
//        printf("\n----- HTTP POST response -----\n");
//        dump_response(post_res);
//
//        delete post_req;
//    }

    Thread::wait(osWaitForever);
}

#endif
